<?php
$title = 'Игра - Коды';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");
if ($adm_id == 1) {

    $count_codes_kat = $connect->query("select count(*) from `kat` where `type` = '22'")->fetchColumn();

    $sys['modules']['codes'] = $sys['modules']['codes'] ?? 1;

    switch ($act) {

        case 'kat':

            if ($sys['modules']['codes'] == 0)
                exit(header('location: /adm/codes'));

            $strow = $connect->prepare("select * from `kat` where `id` = ?");
            $strow->execute(array($id));
            $row = $strow->fetch();

            if ($row && $row['type'] == 22) {

                $stmt_count_codes = $connect->prepare("select count(*) from `codes` where `kat` = ?");
                $stmt_count_codes->execute(array($id));
                $count_codes = $stmt_count_codes->fetchColumn();

                echo '<div class="title">Коды: '.$row['name'].' ('.$count_codes.')</div>';

                $strow = $connect->prepare("select * from `codes` where `kat` = ? and `id` = ?");

                if (isset($_GET['del'])) {
                    $strow->execute(array($id, $_GET['del']));
                    $row = $strow->fetch();
                    if ($row && !$row['uid']) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /adm/codes/kat/'.$id);
                        }
                        elseif (isset($_POST['ok'])) {
                            $stmt = $connect->prepare("delete from `codes` where `id` = ?");
                            if ($stmt->execute(array($_GET['del']))) {
                                header('Location: /adm/codes/kat/'.$id);
                            } else {
                                echo '<div class="menu">Произошла ошибка!</div>';
                            }
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        <input type="submit" name="ok" value="Удалить ('.intval($_GET['del']).')"/> 
                        <input type="submit" name="cancel" value="Отмена"/>
                        </form></div>';
                    } else {
                        header('Location: /adm/codes/kat/'.$id);
                    }
                }
                elseif (isset($_GET['edit'])) {
                    $strow->execute(array($id, $_GET['edit']));
                    $row = $strow->fetch();
                    if ($row && !$row['uid']) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /adm/codes/kat/'.$id);
                        }
                        elseif (isset($_POST['ok'])) {
                            $error = '';
                            if (empty($_POST['code'])) {
                                $error.= 'Введите код!<br/>';
                            }
                            elseif (mb_strlen($_POST['code']) < 6 || mb_strlen($_POST['code']) > 25) {
                                $error.= 'Код должен содержать от 6 до 25 символов!<br/>';
                            }
                            if (empty($_POST['cena'])) {
                                $error.= 'Введите стоимость!<br/>';
                            }
                            elseif ($_POST['cena'] < 0.01) {
                                $error.= 'Стоимость не может быть меньше 0.01!<br/>';
                            }
                            if (empty($_POST['sum'])) {
                                $error.= 'Введите приз!<br/>';
                            }
                            if ($error) {
                                echo '<div class="menu">'.$error.'</div>';
                            } else {
                                $stmt = $connect->prepare("update `codes` set `code` = ?, `cena` = ?, `sum` = ? where `id` = ?");
                                if ($stmt->execute(array($_POST['code'], floatval(abs($_POST['cena'])), floatval(abs($_POST['sum'])), $_GET['edit']))) {
                                    header('Location: /adm/codes/kat/'.$id);
                                } else {
                                    echo '<div class="menu">Произошла ошибка!</div>';
                                }
                            }
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        Код:<br/><input type="text" name="code" value="'.$row['code'].'"><br/>
                        Стоимость кода:<br/><input type="text" name="cena" value="'.$row['cena'].'"><br/>
                        Приз:<br/><input type="text" name="sum" value="'.$row['sum'].'"><br/>
                        <input type="submit" name="ok" value="Сохранить ('.intval($_GET['edit']).')"/> 
                        <input type="submit" name="cancel" value="Отмена"/>
                        </form></div>';
                    } else {
                        header('Location: /adm/codes/kat/'.$id);
                    }
                }

                if ($count_codes == 0) {
                    echo '<div class="menu">Кодов нет!</div>';
                } else {

                    $page = new Pagination($count_codes, 10);

                    $data = $connect->prepare("select * from `codes` where `kat` = :kat order by `id` desc limit :start, 10");
                    $data->bindValue(':kat', $id, PDO::PARAM_INT);
                    $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                    $data->execute();
                    $sql = $data->fetchAll();

                    foreach ($sql as $row) {

                        echo '<div class="menu">
                        Код: <font color="'.Gradient::random_color().'">'.$row['code'].'</font><br/>
                        Стоимость: '.rub($row['cena']).'<br/>
                        Приз: '.rub($row['sum']).'<br/>
                        Активирован: '.($row['opened'] == 1 ? '<span class="wa-span-blue">Да</span>' : '<span class="wa-span-orange">Нет</span>').'<br/>
                        Владелец: '.($row['uid'] ? profileLink($row['uid']) : '<span class="wa-span-red">Нет</span>').
                        (!$row['uid'] ? '<div class="butt2">
                        <a href="?del='.$row['id'].'">Удалить</a>
                        <a href="?edit='.$row['id'].'">Редактировать</a>
                        </div>' : '').'
                        </div>';

                    }

                    $page->navigation();

                }

                echo '<div class="title">Сгенерировать код</div>';

                if (isset($_POST['submit'])) {
                    $error = '';
                    if (empty($_POST['code'])) {
                        $error.= 'Введите код!<br/>';
                    }
                    elseif (mb_strlen($_POST['code']) < 6 || mb_strlen($_POST['code']) > 25) {
                        $error.= 'Код должен содержать от 6 до 25 символов!<br/>';
                    }
                    if (empty($_POST['cena'])) {
                        $error.= 'Введите стоимость!<br/>';
                    }
                    elseif ($_POST['cena'] < 0.01) {
                        $error.= 'Стоимость не может быть меньше 0.01!<br/>';
                    }
                    if (empty($_POST['sum'])) {
                        $error.= 'Введите приз!<br/>';
                    }
                    if ($error) {
                        echo '<div class="menu">'.$error.'</div>';
                    } else {
                        $stmt = $connect->prepare("insert into `codes` set `code` = ?, `cena` = ?, `sum` = ?, `kat` = ?");
                        if ($stmt->execute(array($_POST['code'], floatval(abs($_POST['cena'])), floatval(abs($_POST['sum'])), $id))) {
                            header('Location: /adm/codes/kat/'.$id);
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                }

                echo '<div class="menu">
                <form action="" method="POST">
                Код:<br/><input type="text" name="code" value="'.gen_pass().'"><br/>
                Стоимость кода:<br/><input type="text" name="cena"><br/>
                Приз:<br/><input type="text" name="sum"><br/>
                <input type="submit" name="submit" value="Продолжить">
                </form></div>
                <div class="forlink"><a href="/adm/codes" class="links">Категории</a></div>';

            } else {
                header('location: /adm/codes');
            }

            break;

        default:

            if (isset($_POST['settings'])) {

                $codes = intval($_POST['codes']);

                $sys['modules']['codes'] = $codes;

                write_ini_file(FILE_CONFIG, $sys);

                header('Location: /adm/codes');

            }

            echo '<div class="title">Игра - Коды</div>
            <div class="menu">
            <form action="" method="POST">
            <select name="codes"><option value="1">Модуль включён</option><option ' . ($sys['modules']['codes'] == 0 ? 'selected' : '') . ' value="0">Модуль выключен</option></select>
            <input type="submit" name="settings" value="OK">
            </form></div>';

            if ($sys['modules']['codes'] == 0)
                exit(require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php"));

            echo '<div class="title">Категории кодов ('.$count_codes_kat.')</div>';

            $type = 22;
            $num_u = $connect->prepare("select count(*) from `kat` where `type` = ? and `id` = ?");
            $stmt_count = $connect->prepare("select count(*) from `codes` where `kat` = ?"); 
            $strow = $connect->prepare("select * from `kat` where `id` = ?");

            if (isset($_GET['edit'])) {
                $num_u->execute(array($type, $_GET['edit']));
                if ($num_u->fetchColumn()) {
                    $strow->execute(array($_GET['edit']));
                    $row = $strow->fetch();
                    if (isset($_POST['cancel'])) {
                        header('location: /adm/codes');
                    }
                    elseif (isset($_POST['red'])) {
                        $error = '';
                        if (empty($_POST['name'])) {
                            $error.= 'Введите название!<br/>';
                        }
                        if ($error) {
                            echo '<div class="menu">'.$error.'</div>';
                        } else {
                            $stmt = $connect->prepare("update `kat` set `name` = ? where `id` = ?");
                            if ($stmt->execute(array($_POST['name'], $_GET['edit']))) {
                                header('location: /adm/codes');
                            } else {
                                echo '<div class="menu">Произошла ошибка!</div>';
                            }
                        }
                    }
                    echo '<div class="menu">
                    <form action="" method="POST">
                    Название:<br/><input type="text" name="name" value="'.$row['name'].'"><br/>
                    <input type="submit" name="red" value="Сохранить ('.intval($_GET['edit']).')">
                    <input type="submit" name="cancel" value="Отмена">
                    </form></div>';
                } else {
                    header('location: /adm/codes');
                }
            }
            elseif (isset($_GET['del'])) {
                $num_u->execute(array($type, $_GET['del']));
                if ($num_u->fetchColumn()) {
                    if (isset($_POST['yes'])) {
                        $stmt = $connect->prepare("delete from `kat` where `id` = ?");
                        $del = $connect->prepare("delete from `codes` where `kat` = ? and `uid` = ?");
                        if ($stmt->execute(array($_GET['del'])) &&
                            $del->execute(array($_GET['del'], 0))) {
                            header('location: /adm/codes');
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                    elseif (isset($_POST['no'])) {
                        header('location: /adm/codes');
                    }

                    echo '<div class="menu">
                    <form action="" method="POST">
                    <input type="submit" name="yes" value="Удалить ('.intval($_GET['del']).')"/> 
                    <input type="submit" name="no" value="Отмена"/>
                    </form></div>';
                } else {
                    header('location: /adm/codes');
                }
            }

            if ($count_codes_kat == 0) {
                echo '<div class="menu">Разделов нет!</div>';
            } else {

                $page = new Pagination($count_codes_kat, 10);

                $data = $connect->prepare("select * from `kat` where `type` = :type order by `id` desc limit :start, 10");
                $data->bindValue(':type', $type, PDO::PARAM_INT);
                $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                $data->execute();
                $sql = $data->fetchAll();

                foreach ($sql as $row) {

                    $stmt_count->execute(array($row['id']));
                    $count = $stmt_count->fetchColumn();

                    echo '<div class="menu">
                    Название: '.$row['name'].'<br/>
                    Кодов: '.$count.'
                    <div class="butt2">
                    <a href="/adm/codes/kat/'.$row['id'].'">Перейти в категорию</a>
                    <a href="?del='.$row['id'].'">Удалить</a>
                    <a href="?edit='.$row['id'].'">Редактировать</a>
                    </div>
                    </div>';

                }

                $page->navigation();

            }

            echo '<div class="title">Новый раздел</div>';
            if (isset($_POST['submit'])) {
                $error = '';
                if (empty($_POST['name'])) {
                    $error.= 'Введите название!<br/>';
                }
                if ($error) {
                    echo '<div class="menu">'.$error.'</div>';
                } else {
                    $stmt = $connect->prepare("insert into `kat` set `type` = ?, `name` = ?");
                    if ($stmt->execute(array($type, $_POST['name']))) {
                        header('location: /adm/codes'); 
                    } else {
                        echo '<div class="menu">Произошла ошибка!</div>';
                    }
                }
            }

            echo '<div class="menu">
            <form action="" method="POST">
            Название:<br/><input type="text" name="name"><br/>
            <input type="submit" name="submit" value="Добавить">
            </form></div>';

    }

} else {
    header('location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>