<?php
$title = 'Игра - коды';
require_once($_SERVER["DOCUMENT_ROOT"]."/inc/head.php");
$sys['modules']['codes'] = $sys['modules']['codes'] ?? 1;
if (isset($active) && $sys['modules']['codes'] == 1) {

    $stmt_my = $connect->prepare("select count(*) from `codes` where `uid` = ?"); 
    $stmt_my->execute(array($user['id']));
    $count_myCodes = $stmt_my->fetchColumn();

    $count_codes_kat = $connect->query("select count(*) from `kat` where `type` = '22'")->fetchColumn();

    switch ($act) {

        case 'kat':

            $strow = $connect->prepare("select * from `kat` where `id` = ?");
            $strow->execute(array($id));
            $row = $strow->fetch();

            if ($row && $row['type'] == 22) {

                $stmt_count_codes = $connect->prepare("select count(*) from `codes` where `kat` = ? and `uid` = '0'");
                $stmt_count_codes->execute(array($id));
                $count_codes = $stmt_count_codes->fetchColumn();

                echo '<div class="title">Коды: '.$row['name'].' ('.$count_codes.')</div>';

                $strow = $connect->prepare("select * from `codes` where `kat` = ? and `id` = ?");

                if (isset($_GET['buy'])) {
                    $strow->execute(array($id, $_GET['buy']));
                    $row = $strow->fetch();
                    if ($row && !$row['uid']) {
                        if (isset($_POST['cancel'])) {
                            header('Location: /codes/kat/'.$id);
                        }
                        elseif (isset($_POST['ok'])) {
                            $error = '';
                            if ($user['money'] < $row['cena']) {
                                $error.= 'Недостаточно средств!<br/>';
                            }
                            if ($error) {
                                echo '<div class="menu">'.$error.'</div>';
                            } else {
                                $stmt = $connect->prepare("update `codes` set `uid` = ? where `id` = ?");
                                if (pay(-$row['cena'], $user['id']) && $stmt->execute(array($user['id'], $_GET['buy']))) {
                                    header('Location: /codes/my');
                                } else {
                                    echo '<div class="menu">Произошла ошибка!</div>';
                                }
                            }
                        }
                        echo '<div class="menu">
                        <form action="" method="POST">
                        <input type="submit" name="ok" value="Купить код ('.rub($row['cena']).')"/> 
                        <input type="submit" name="cancel" value="Отмена"/>
                        </form></div>';
                    } else {
                        header('Location: /codes/kat/'.$id);
                    }
                }

                if ($count_codes == 0) {
                    echo '<div class="menu">Кодов нет!</div>';
                } else {

                    $page = new Pagination($count_codes, 12);

                    $data = $connect->prepare("select * from `codes` where `kat` = :kat and `uid` = '0' order by `id` desc limit :start, 12");
                    $data->bindValue(':kat', $id, PDO::PARAM_INT);
                    $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                    $data->execute();
                    $sql = $data->fetchAll();

                    $i = 0;

                    echo '<div class="menu">
                    <div class="butt9">';

                    foreach ($sql as $row) {

                        $i++;

                        echo '<a href="?buy='.$row['id'].'"><font color="'.Gradient::random_color().'">'.$row['code'].'</font></a>';

                        if ($i == 3) {

                            $i = 0;

                            echo '<br/>';

                        }

                    }

                    echo '</div></div>';

                    $page->navigation();

                }

                echo '<div class="forlink"><a href="/codes" class="links"><img src="/img/codes.png" alt="codes">Игра - Коды</a></div>';

            } else {
                header('location: /codes');
            }

            break;

        case 'my':

            echo '<div class="title">Мои коды ('.$count_myCodes.')</div>';

            $strow = $connect->prepare("select * from `codes` where `uid` = ? and `id` = ?");

            if (isset($_GET['active'])) {
                $strow->execute(array($user['id'], $_GET['active']));
                $row = $strow->fetch();
                if ($row && !$row['opened']) {
                    if (isset($_POST['cancel'])) {
                        header('Location: /codes/my');
                    }
                    elseif (isset($_POST['ok'])) {
                        $stmt = $connect->prepare("update `codes` set `opened` = ? where `id` = ?");
                        if (pay($row['sum'], $user['id']) && $stmt->execute(array(1, $_GET['active']))) {
                            echo '<div class="menu">
                            <div class="good">Код активирован! Приз - '.rub($row['sum']).'</div>
                            (<a href="/codes/my">Назад</a>)
                            </div>';
                        } else {
                            echo '<div class="menu">Произошла ошибка!</div>';
                        }
                    }
                    echo '<div class="menu">
                    <form action="" method="POST">
                    <input type="submit" name="ok" value="Активировать код ('.$row['code'].')"/> 
                    <input type="submit" name="cancel" value="Отмена"/>
                    </form></div>';
                } else {
                    header('Location: /codes/my');
                }
            }

            if ($count_myCodes == 0) {
                echo '<div class="menu">Кодов нет!</div>';
            } else {

                $page = new Pagination($count_myCodes, 10);

                $data = $connect->prepare("select * from `codes` where `uid` = :uid order by `id` desc limit :start, 10");
                $data->bindValue(':uid', $user['id'], PDO::PARAM_INT);
                $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                $data->execute();
                $sql = $data->fetchAll();

                foreach ($sql as $row) {

                    echo '<div class="menu">
                    Код: <font color="'.Gradient::random_color().'">'.$row['code'].'</font><br/>
                    Приз: '.($row['opened'] ? '<span class="wa-span-green">'.rub($row['sum']).'</span>' : '<span class="wa-span-red">Неизвестно</span>').'<br/>
                    Активирован: '.($row['opened'] == 1 ? '<span class="wa-span-blue">Да</span>' : '<span class="wa-span-orange">Нет</span>').'<br/>
                    '.(!$row['opened'] ? '<div class="butt5">
                    <a href="?active='.$row['id'].'">Активировать</a>
                    </div>' : '').'
                    </div>';
                }

                $page->navigation();

            }

            echo '<div class="forlink"><a href="/codes" class="links"><img src="/img/codes.png" alt="codes">Игра - Коды</a></div>';

            break;

        default:

            echo '<div class="title">Игра - Коды</div>
            <div class="forlink"><a href="/codes/my" class="links"><img src="/img/codes.png" alt="codes">Мои коды<div class="chi">'.$count_myCodes.'</div></a></div>';

            $type = 22;

            $stmt_count = $connect->prepare("select count(*) from `codes` where `kat` = ? and `uid` = '0'"); 

            if ($count_codes_kat == 0) {
                echo '<div class="menu">Разделов нет!</div>';
            } else {

                $page = new Pagination($count_codes_kat, 10);

                $data = $connect->prepare("select * from `kat` where `type` = :type order by `id` desc limit :start, 10");
                $data->bindValue(':type', $type, PDO::PARAM_INT);
                $data->bindValue(':start', $page->start, PDO::PARAM_INT);
                $data->execute();
                $sql = $data->fetchAll();

                foreach ($sql as $row) {

                    $stmt_count->execute(array($row['id']));
                    $count = $stmt_count->fetchColumn();

                    echo '<div class="forlink"><a href="/codes/kat/'.$row['id'].'" class="links"><img src="/img/folder.png" alt="folder">'.$row['name'].'<div class="chi">'.$count.'</div></a></div>';

                }

                $page->navigation();

            }

    }


} else {
    header('Location: /');
}

require($_SERVER["DOCUMENT_ROOT"]."/inc/foot.php");
?>